/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getAssertedStatements;

import java.util.Collection;
import java.util.UUID;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.Statement;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.base.WriteReadTest;
import org.simantics.db.tests.common.Writes;

public class GetAssertedStatementsTest4 extends WriteReadTest {

    private Resource type;
    private Resource type2;
    private Resource type3;
    private Resource string1;
    private Resource string2;
    
    @Override
    protected void write(WriteGraph graph) throws DatabaseException {
        
        // New type with assertions
        type2 = graph.newResource();
        graph.claim(type2, L0.Inherits, L0.Entity);
        type3 = graph.newResource();
        graph.claim(type3, L0.Inherits, L0.Entity);
        type = graph.newResource();
        graph.claim(type, L0.Inherits, type2);
        graph.claim(type, L0.Inherits, type3);
        
        string1 = Writes.string(graph, UUID.randomUUID().toString());
        string2 = Writes.string(graph, UUID.randomUUID().toString());

        // Assert two functional objects
        graph.claim(type2, L0.Asserts, Writes.assertion(graph, L0.HasName, string1));
        graph.claim(type3, L0.Asserts, Writes.assertion(graph, L0.HasName, string2));
        
    }

    @Override
    protected void read(ReadGraph graph) throws DatabaseException {
        Collection<Statement> stms = graph.getAssertedStatements(type, L0.HasName);
         assertNotNull("Null not allowed", stms);
         assertTrue("Must return both objects.", 2 == stms.size());
    }

}
