/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getPrincipalTypes;

import java.util.Collection;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.base.WriteReadTest;

public class GetPrincipalTypesTest2 extends WriteReadTest {

    private Resource type1;
    private Resource type2;
    private Resource type3;
    private Resource instance1;
    
	@Override
	protected void write(WriteGraph graph) throws DatabaseException {

        type1 = graph.newResource();
        graph.claim(type1, L0.Inherits, L0.Entity);
        type2 = graph.newResource();
        graph.claim(type2, L0.Inherits, L0.Entity);
        type3 = graph.newResource();
        //graph.claim(type3, L0.Inherits, L0.Entity);

        graph.claim(type3, L0.Inherits, type1);
        graph.claim(type3, L0.Inherits, type2);
        instance1 = graph.newResource();
        graph.claim(instance1, L0.InstanceOf, type3);		
	}

	@Override
    protected void read(ReadGraph graph) throws DatabaseException {
        Collection<Resource> result = graph.getPrincipalTypes(instance1);
        assertNotNull("Null not allowed", result);
        int resultsSize = result.size();
        assertTrue("Null results.", (result != null));
        assertTrue("Wrong types", (result.contains(type3)));
        assertTrue("Wrong number of results: " + resultsSize,
        		(resultsSize == 1));
    }
	/*
	@Override
    protected void read(ReadGraph graph) throws DatabaseException {
    	
        Collection<Resource> results = graph.getSupertypes(instance1);
        int resultsSize = results.size();
        assertTrue("Null results.", (results != null));
        System.out.println(results.contains(L0.Entity) + " " + results.contains(type3)+
        		" " + results.contains(type1) + " " + results.contains(type2));
        //Collection<Resource> labels = graph.getObjects(type3, L0.HasLabel);
        //assertTrue("Wrong type" + labels.toArray()[0], results.contains(type1));
        assertTrue("Wrong number of results: " + resultsSize,
        		(resultsSize == 2));
        //assertTrue(Tests.contains(statements, L0.SupertypeOf, named1));
        //assertTrue(Tests.contains(statements, L0.SupertypeOf, named2));
        
        
    }
    */
    
}
