/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.request.misc;

import java.util.Set;

import org.junit.Test;
import org.simantics.db.AsyncReadGraph;
import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.Session;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.impl.query.CacheEntry;
import org.simantics.db.impl.service.QueryDebug;
import org.simantics.db.procedure.AsyncMultiListener;
import org.simantics.db.request.Read;
import org.simantics.db.testing.base.SimpleBase;
import org.simantics.layer0.Layer0;

public class RequestParentTest5 extends SimpleBase {
	
	@Test
	public void test() throws Exception {
		
		Session session = getSession();
		
		QueryDebug debug = session.getService(QueryDebug.class);
		
        class Request implements Read<Object> {

            @Override
            public Object perform(ReadGraph graph) throws DatabaseException {
                return new Object();
            }
            
        }
		
        final Request request = new Request();
        
        session.syncRequest(new TestAsyncReadRequest() {

            @Override
            public void run(AsyncReadGraph graph) throws Throwable {
                Layer0 l0 = Layer0.getInstance(graph);
                graph.forEachObject(rl, l0.InstanceOf, new AsyncMultiListener<Resource>() {

                    @Override
                    public void exception(AsyncReadGraph graph, Throwable t) {
                    }

                    @Override
                    public void execute(AsyncReadGraph graph, Resource result) {
                        graph.asyncRequest(request);
                    }

                    @Override
                    public boolean isDisposed() {
                        return false;
                    }

                    @Override
                    public void finished(AsyncReadGraph graph) {
                    }

                });
                
            }
            
        });
		
		Set<CacheEntry> parents = debug.getParents(request);
		if(!parents.isEmpty())fail("Request2 should not have parents");
		
	}

}
