/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.request.misc;

import org.junit.Test;
import org.simantics.db.AsyncReadGraph;
import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.Session;
import org.simantics.db.Statement;
import org.simantics.db.common.primitiverequest.PossibleStatement;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.procedure.AsyncListener;
import org.simantics.db.procedure.SyncListener;
import org.simantics.db.testing.base.ExistingDatabaseTest;
import org.simantics.layer0.Layer0;

public class SyncAsyncSyncTest9 extends ExistingDatabaseTest {
	
	@Test
	public void test() throws Exception {
		
		Session session = getSession();
		
        session.syncRequest(new TestAsyncReadRequest() {

            @Override
            public void run(AsyncReadGraph g) throws Throwable {

                final Layer0 b = Layer0.getInstance(g);

                g.forPossibleObject(g.getRootLibrary(), b.InstanceOf, new AsyncListener<Resource>() {

                    @Override
                    public void execute(AsyncReadGraph graph, Resource type) {

                        graph.asyncRequest(new PossibleStatement(type, b.InstanceOf), new SyncListener<Statement>() {

                            @Override
                            public void exception(ReadGraph graph, Throwable throwable) throws DatabaseException {
                            }

                            @Override
                            public void execute(ReadGraph graph, Statement result) throws DatabaseException {
                            }

                            @Override
                            public boolean isDisposed() {
                                return false;
                            }
                            
                        });

//                        graph.syncRequest(new ForObjectSet(type, b.Inherits, new SyncSetListener<Resource>() {
//
//                            @Override
//                            public void add(ReadGraph graph, Resource result) throws DatabaseException {
//                                
//                                System.out.println(GraphUtils.getReadableName(graph, result));
//                                
//                                graph.asyncRequest(new PossibleStatement(result, b.InstanceOf), new SyncListener<Statement>() {
//
//                                    @Override
//                                    public void exception(ReadGraph graph, Throwable throwable) throws DatabaseException {
//                                    }
//
//                                    @Override
//                                    public void execute(ReadGraph graph, Statement result) throws DatabaseException {
//                                    }
//
//                                    @Override
//                                    public boolean isDisposed() {
//                                        return false;
//                                    }
//                                    
//                                });
//                                
//                            }
//
//                            @Override
//                            public void exception(ReadGraph graph, Throwable throwable) throws DatabaseException {
//                                assert(false);
//                            }
//
//                            @Override
//                            public void remove(ReadGraph graph, Resource result) throws DatabaseException {
//                                assert(false);
//                            }
//
//                            @Override
//                            public boolean isDisposed() {
//                                return false;
//                            }
//                            
//                        }));
                        
                    }

                    @Override
                    public void exception(AsyncReadGraph graph, Throwable throwable) {
                        throwable.printStackTrace();
                        assert(false);
                    }

                    @Override
                    public boolean isDisposed() {
                        return false;
                    }
                    
                });
                
            }
            
        });
        
	}

}
