package org.simantics.db.tests.api.story.sessionGarbageCollection;

import java.util.ArrayList;
import java.util.Collections;

import org.simantics.databoard.Bindings;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.common.utils.ListUtils;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.layer0.util.SessionGarbageCollection;
import org.simantics.db.testing.common.WriteCommand;
import org.simantics.layer0.Layer0;

public class AddListAndKill extends WriteCommand<CollectDuringWriteAndRead> {

	@Override
	protected void run(WriteGraph graph, CollectDuringWriteAndRead environment) throws DatabaseException {

		Layer0 L0 = Layer0.getInstance(graph);
		Resource root = environment.getRoot();
		int listSize = environment.getListSize();
		int index = environment.incrementAndGetIndex();

		Resource r = ListUtils.create(graph, Collections.<Resource>emptyList());
		graph.addLiteral(r, L0.HasName, L0.NameOf, L0.String, "" + (index), Bindings.STRING);
		graph.claim(root, L0.ConsistsOf, r);

		for(int i=0,index2=0;i<3;i++) {
			ArrayList<Resource> rs = new ArrayList<Resource>();
			for(int j=0;j<listSize;j++) {
				Resource r2 = graph.newResource();
				graph.addLiteral(r2, L0.HasName, L0.NameOf, L0.String, "" + (index) + "-" + index2++, Bindings.STRING);
				rs.add(r2);
			}
			ListUtils.insertBack(graph, r, rs);
			SessionGarbageCollection.gc(graph, Integer.MAX_VALUE, 0);
		}
	}

	@Override
	protected void afterRun(CollectDuringWriteAndRead environment) throws Exception {
	}

}