package org.simantics.db.tests.api.support.managementSupport;

import org.junit.Test;
import org.simantics.db.ReadGraph;
import org.simantics.db.common.request.ReadRequest;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.service.ManagementSupport;
import org.simantics.db.testing.base.ExistingDatabaseTest;

public class GetHeadRevisionTest extends ExistingDatabaseTest {
    @Test
    public void test() throws DatabaseException {
        final ManagementSupport ms = getSession().getService(ManagementSupport.class);
        final long revisionId = ms.getHeadRevisionId();
        assertTrue(revisionId > 0);
        getSession().syncRequest(new ReadRequest() {
            @Override
            public void run(ReadGraph g) throws DatabaseException {
                long id = ms.getHeadRevisionId();
                assertTrue(revisionId == id);
            }
        });
    }

}
