/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.write.story;

import org.junit.Test;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.testing.base.ExistingDatabaseTest;
import org.simantics.db.testing.common.WriteQuery;
import org.simantics.layer0.Layer0;

/**
 * Creates large amount of instances in multiple transactions
 * and the tries to verify that instances are written into the database.
 * 
 * @author Marko Luukkainen <marko.luukkainen@vtt.fi>
 *
 */
public class WriteIntoBuiltinResourceTest extends ExistingDatabaseTest {
	
	@Test
	public void test() throws Exception{

	    final Resource rootLib = getSession().getRootLibrary();
		
        getSession().syncRequest(new WriteQuery(this) {
            @Override
            public void run(WriteGraph g) throws Throwable {
                
                Layer0 b = Layer0.getInstance(g);
                try {
                    g.claim(rootLib, b.IsRelatedTo, rootLib);
                } catch (Throwable t)  {
                    new Exception().printStackTrace();
                }
                
            }
            
        });
        
        checkException();
		
	}

}
