package org.simantics.db.tests.regression;

import org.junit.BeforeClass;
import org.junit.runner.RunWith;
import org.junit.runners.Suite.SuiteClasses;
import org.simantics.db.common.utils.Logger;
import org.simantics.db.testing.common.RegressionSuiteRunner;
import org.simantics.db.testing.common.Tests;
import org.simantics.db.tests.regression.bugs.CommentMetadataWriteTest;
import org.simantics.db.tests.regression.bugs.Issue2967Test1;
import org.simantics.db.tests.regression.bugs.Issue3072Test1;
import org.simantics.db.tests.regression.bugs.Issue3108Test1;
import org.simantics.db.tests.regression.bugs.Issue3176Test1;
import org.simantics.db.tests.regression.bugs.Issue3176Test2;
import org.simantics.db.tests.regression.bugs.Issue3176Test3;
import org.simantics.db.tests.regression.bugs.Issue3199Test1;
import org.simantics.db.tests.regression.bugs.Issue3199Test2;
import org.simantics.db.tests.regression.bugs.Issue3420Test1;
import org.simantics.db.tests.regression.bugs.Issue3420Test2;
import org.simantics.db.tests.regression.bugs.Issue4688Test1;
import org.simantics.db.tests.regression.bugs.Issue5432Test1;
import org.simantics.db.tests.regression.bugs.SimanticsBug1659Test1;
import org.simantics.db.tests.regression.bugs.SimanticsBug1659Test2;
import org.simantics.db.tests.regression.bugs.SimanticsBug1659Test3;
import org.simantics.db.tests.regression.bugs.SimanticsBug1893Test1;
import org.simantics.db.tests.regression.bugs.SimanticsBug3114Test;
import org.simantics.db.tests.regression.bugs.SimanticsBug639Test;
import org.simantics.db.tests.regression.bugs.SimanticsFeature4007Test1;
import org.simantics.db.tests.regression.bugs.SyncWriteReadTest1;
import org.simantics.db.tests.regression.bugs.TicketTest646;
import org.simantics.db.tests.regression.bugs.WriteCancelTest3;

@RunWith(RegressionSuiteRunner.class)
@SuiteClasses({
    CommentMetadataWriteTest.class,
    Issue2967Test1.class,
    Issue3072Test1.class,
    Issue3108Test1.class,
    Issue3176Test1.class,
    Issue3176Test2.class,
    Issue3176Test3.class,
    Issue3199Test1.class,
    Issue3199Test2.class,
    Issue3420Test1.class,
    Issue3420Test2.class,
    Issue3420Test2.class,
    Issue4688Test1.class,
    Issue5432Test1.class,
    Issue5432Test1.class,
    SimanticsBug1659Test1.class,
    SimanticsBug1659Test2.class,
    SimanticsBug1659Test3.class,
    SimanticsBug1893Test1.class,
    SimanticsBug3114Test.class,
    SimanticsBug639Test.class,
    SimanticsFeature4007Test1.class,
    SyncWriteReadTest1.class,
    TicketTest646.class,
    WriteCancelTest3.class,
})
public class SuiteRegression {

    @BeforeClass
    public static void setUp() {
        try {
            Tests.freshDatabase();
        } catch (Exception e) {
            Logger.defaultLogError(e);
        }
    }

}
