/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
import java.util.Collection;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.Session;
import org.simantics.db.common.request.ReadRequest;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.service.LifecycleSupport;
import org.simantics.db.testing.common.Tests;
import org.simantics.layer0.Layer0;


public class Local2 {
	static String newInstanceName ="Local1InstanceName";
	static Session session = null;
	public static void main(String[] args) {
		try {
			session = Tests.getTestHandler().getSession();
	        session.syncRequest(new ReadRequest() {
	            @Override
	            public void run(ReadGraph g) throws DatabaseException {
	                Layer0 b = Layer0.getInstance(g);
	                int count = 0;
					Collection<Resource> resources = g.getObjects(g.getRootLibrary(), b.ConsistsOf);
					for (Resource r : resources) {
					    String value = g.getPossibleRelatedValue(r, b.HasName);
						if (null != value && value.equals(newInstanceName)) {
						    count++;
						}
					}
					System.out.println("instance count = " + count);
				}
	        });

	        LifecycleSupport ls = session.getService(LifecycleSupport.class);
//            PublishSynchroniseSupport pss = session.getService(PublishSynchroniseSupport.class);
//            pss.synchronize();

	        session.syncRequest(new ReadRequest() {
	            @Override
	            public void run(ReadGraph g) throws DatabaseException {
	                Layer0 b = Layer0.getInstance(g);
	                int count = 0;
					Collection<Resource> resources = g.getObjects(g.getRootLibrary(), b.ConsistsOf);
					for (Resource r : resources) {
					    String value = g.getPossibleRelatedValue(r, b.HasName);
						if (null != value && value.equals(newInstanceName)) {
						    count++;
						}
					}
					System.out.println("instance count = " + count);
				}
	        });

            ls.close();
            System.out.println("Ok.");
//		} catch (ClassNotFoundException e) {
//			e.printStackTrace();
		} catch (DatabaseException e) {
			e.printStackTrace();
		}
	}
}
