package org.simantics.scl.compiler.tests;

import java.io.StringReader;
import java.io.StringWriter;

import org.junit.Assert;
import org.junit.Test;
import org.simantics.scl.compiler.commands.CommandSessionWithModules;
import org.simantics.scl.osgi.SCLOsgi;

public class TestCommandSessionWithModules {
    @Test
    public void testCommandSessionWithModules() {
        CommandSessionWithModules session = new CommandSessionWithModules(SCLOsgi.MODULE_REPOSITORY);
        session.putModule("My/Test/Module", "someValue = 13");
        
        {
            StringWriter writer = new StringWriter();
            session.runCommands(new StringReader("import \"My/Test/Module\"\nsomeValue"), writer);
            Assert.assertEquals("13\n", writer.toString());
        }
        
        session.putModule("My/Test/Module", "someValue = 14");
        
        {
            StringWriter writer = new StringWriter();
            session.runCommands(new StringReader("someValue\nsomeValue+1"), writer);
            Assert.assertEquals("14\n15\n", writer.toString());
        }
    }
}
